<p>
<a name="$BW"></a>[1] 
R. Bird and P. Wadler.
<I>Introduction to functional programming</I>.
Prentice Hall, 1988.<p>
<a name="$paramTC"></a>[2] 
K. Chen, P. Hudak, and M. Odersky.
Parametric type classes (extended abstract).
In <I>ACM conference on LISP and Functional Programming</I>,
  San Francisco, CA, June 1992.<p>
<a name="$GasterJones"></a>[3] 
B. R. Gaster and M. P. Jones.
A polymorphic type system for extensible records and variants.
Technical Report NOTTCS-TR-96-3, Computer Science, University of
  Nottingham, November 1996.<p>
<a name="$GentleIntro"></a>[4] 
P. Hudak and J. Fasel.
A gentle introduction to Haskell.
<I>ACM SIGPLAN Notices</I>, 27(5), May 1992.
Also available as Research Report YALEU/DCS/RR-901, Yale University,
  Department of Computer Science, April 1992.<p>
<a name="$MonParse"></a>[5] 
G. Hutton and E. Meijer.
Monadic parser combinators.
Available from 
<tt>  http://www.cs.nott.ac.uk/Department/Staff/gmh/bib.html</tt>, 1996.<p>
<a name="$Gofer"></a>[6] 
M. Jones.
The implementation of the Gofer functional programming system.
Research Report YALEU/DCS/RR-1030, Yale University, New Haven,
  Connecticut, USA, May 1994.
Available on the World-Wide Web from 
<tt>  http://www.cse.ogi.edu/mpj/pubs.html</tt>.<p>
<a name="$improvement"></a>[7] 
M. P. Jones.
Simplifying and improving qualified types.
In <I>International Conference on Functional Programming Languages
  and Computer Architecture</I>, pages 160--169, June 1995.<p>
<a name="$Haskell98"></a>[8] 
S. Peyton Jones and J. Hughes (editors).
<I>Report on the Programming Language Haskell 98, A
  Non-strict Purely Functional Language</I>, February 1999.
Available from <tt>http://www.haskell.org/definition/</tt>.<p>
<a name="$Haskell98libs"></a>[9] 
S. Peyton Jones and J. Hughes (editors).
<I>Standard libraries for the Haskell 98 programming language</I>,
  February 1999.
Available from <tt>http://www.haskell.org/definition/</tt>.<p>
<a name="$HugsGHClibs"></a>[10] 
The Hugs/GHC Team.
<I>The Hugs-GHC Extension Libraries</I>, January 1999.
Available from <tt>http://www.haskell.org/libraries/</tt>.<p>

